-- This file is auto GENERATED from metadata.xml file.
-- DO NOT MODIFY THIS FILE!!!
-- All changes should be made to metadata.xml instead.


-- Represents User Information
IF EXISTS(SELECT * FROM sysobjects WHERE (name='Contact') AND (xtype='U'))
	DROP TABLE [Contact]
GO

CREATE TABLE [Contact] (
	[id] INT IDENTITY(1,1),
	[fname] VARCHAR(32),
	[lname] VARCHAR(32),
	[email] VARCHAR(64),
	[url] VARCHAR(128),
	[phone] VARCHAR(32),
	[fax] VARCHAR(32),
	[street] VARCHAR(64),
	[city] VARCHAR(32),
	[state] CHAR(2),
	[zip] CHAR(5),
	PRIMARY KEY([id])
);

GO

-- Stored Procedures to work with the table.

-- Creates a new Contact record entry.
IF EXISTS(SELECT * FROM sysobjects WHERE (name='CreateContact') AND (xtype='P'))
	DROP PROCEDURE CreateContact
GO

CREATE PROCEDURE CreateContact
(
	@fname VARCHAR(32),
	@lname VARCHAR(32),
	@email VARCHAR(64),
	@url VARCHAR(128),
	@phone VARCHAR(32),
	@fax VARCHAR(32),
	@street VARCHAR(64),
	@city VARCHAR(32),
	@state CHAR(2),
	@zip CHAR(5)
) 
AS 
INSERT INTO [Contact] (
	[fname],
	[lname],
	[email],
	[url],
	[phone],
	[fax],
	[street],
	[city],
	[state],
	[zip]
) 
VALUES
(
	@fname,
	@lname,
	@email,
	@url,
	@phone,
	@fax,
	@street,
	@city,
	@state,
	@zip
)
RETURN @@IDENTITY 

GO


-- Update a Contact record in the database.
IF EXISTS(SELECT * FROM sysobjects WHERE (name='UpdateContact') AND (xtype='P'))
	DROP PROCEDURE UpdateContact
GO

CREATE PROCEDURE UpdateContact
(
	@id INT,
	@fname VARCHAR(32),
	@lname VARCHAR(32),
	@email VARCHAR(64),
	@url VARCHAR(128),
	@phone VARCHAR(32),
	@fax VARCHAR(32),
	@street VARCHAR(64),
	@city VARCHAR(32),
	@state CHAR(2),
	@zip CHAR(5)
) 
AS 
	UPDATE [Contact]
	SET
	[fname]=@fname,
	[lname]=@lname,
	[email]=@email,
	[url]=@url,
	[phone]=@phone,
	[fax]=@fax,
	[street]=@street,
	[city]=@city,
	[state]=@state,
	[zip]=@zip
	WHERE [id]=@id
GO


-- Delete a Contact record from the database.
IF EXISTS(SELECT * FROM sysobjects WHERE (name='DeleteContact') AND (xtype='P'))
	DROP PROCEDURE DeleteContact
GO

CREATE PROCEDURE DeleteContact
(
	@id INT
) 
AS 
	DELETE FROM [Contact]
	WHERE [id]=@id
GO


-- Get a Contact record by primary key.
IF EXISTS(SELECT * FROM sysobjects WHERE (name='GetContact') AND (xtype='P'))
	DROP PROCEDURE GetContact
GO

CREATE PROCEDURE GetContact
(
	@id INT
) 
AS 
	SELECT * 
	FROM [Contact]
	WHERE [id]=@id
GO


-- Get 'all' Contact records; it actually gets TOP 256 records.
IF EXISTS(SELECT * FROM sysobjects WHERE (name='GetAllContacts') AND (xtype='P'))
	DROP PROCEDURE GetAllContacts
GO

CREATE PROCEDURE GetAllContacts
AS
	SELECT TOP 1024 * 
	FROM [Contact]

GO


-- Get Count of all Contact records.
IF EXISTS(SELECT * FROM sysobjects WHERE (name='GetContactCount') AND (xtype='P'))
	DROP PROCEDURE GetContactCount
GO

CREATE PROCEDURE GetContactCount
AS
	SELECT COUNT(*) 
	FROM [Contact]

GO

-- Lookup contact by first name/last name.
IF EXISTS(SELECT * FROM sysobjects WHERE (name='GetFindContact') AND (xtype='P'))
	DROP PROCEDURE GetFindContact
GO

CREATE PROCEDURE GetFindContact
(
	@qstr VARCHAR(32)
) 
AS 
	SELECT * FROM Contact WHERE fname like '%'+@qstr+'%' OR lname like '%'+@qstr+'%'

GO

