/*
 * ContactDB.cs
 *
 * THIS FILE IS AUTO-GENERATED FROM metadata.xml.
 * DO NOT UPDATE THIS FILE.
 * ANY CHANGES TO THIS FILE WILL BE LOST!!!
 * ALL CHANGES MUST BE MADE TO metadata.xml.
 */


using System;
using System.Data;
using System.Data.SqlClient;
using System.Collections;

namespace SAMPLEAPP {

	/**
	 * ContactDB
	 * A database proxy class for Contact class.
	 *
	 * This is the stateless (static) service provider class
	 * to create, update, retrieve, and delete Contact
	 * objects.
	 *
	 * This class uses SqlClient package to work with SQL Server.
	 *
	 * Application settings need to have "dbconnectstr" key defined!!!
	 *
	 * You never need to create an instance of this class.
	 */
	public class ContactDB
	{
		///<summary>This method creates a new Contact object in database; 
		/// using a given database connection, and a started transaction.</summary>
		public static Int32 CreateContact(Contact o, SqlConnection conn, SqlTransaction trans)
		{
			SqlCommand cmd = new SqlCommand("CreateContact",conn);
			cmd.CommandType = CommandType.StoredProcedure;
			SqlParameter return_value = cmd.Parameters.Add("RETURN_VALUE", SqlDbType.Int);
			return_value.Direction = ParameterDirection.ReturnValue;
			SqlParameter param_fname = cmd.Parameters.Add("@fname", SqlDbType.VarChar);
			if(((object)o.Fname) == null){
				param_fname.Value = DBNull.Value;
			}else{
				param_fname.Value = o.Fname;
			}
			SqlParameter param_lname = cmd.Parameters.Add("@lname", SqlDbType.VarChar);
			if(((object)o.Lname) == null){
				param_lname.Value = DBNull.Value;
			}else{
				param_lname.Value = o.Lname;
			}
			SqlParameter param_email = cmd.Parameters.Add("@email", SqlDbType.VarChar);
			if(((object)o.Email) == null){
				param_email.Value = DBNull.Value;
			}else{
				param_email.Value = o.Email;
			}
			SqlParameter param_url = cmd.Parameters.Add("@url", SqlDbType.VarChar);
			if(((object)o.Url) == null){
				param_url.Value = DBNull.Value;
			}else{
				param_url.Value = o.Url;
			}
			SqlParameter param_phone = cmd.Parameters.Add("@phone", SqlDbType.VarChar);
			if(((object)o.Phone) == null){
				param_phone.Value = DBNull.Value;
			}else{
				param_phone.Value = o.Phone;
			}
			SqlParameter param_fax = cmd.Parameters.Add("@fax", SqlDbType.VarChar);
			if(((object)o.Fax) == null){
				param_fax.Value = DBNull.Value;
			}else{
				param_fax.Value = o.Fax;
			}
			SqlParameter param_street = cmd.Parameters.Add("@street", SqlDbType.VarChar);
			if(((object)o.Street) == null){
				param_street.Value = DBNull.Value;
			}else{
				param_street.Value = o.Street;
			}
			SqlParameter param_city = cmd.Parameters.Add("@city", SqlDbType.VarChar);
			if(((object)o.City) == null){
				param_city.Value = DBNull.Value;
			}else{
				param_city.Value = o.City;
			}
			SqlParameter param_state = cmd.Parameters.Add("@state", SqlDbType.Char);
			if(((object)o.State) == null){
				param_state.Value = DBNull.Value;
			}else{
				param_state.Value = o.State;
			}
			SqlParameter param_zip = cmd.Parameters.Add("@zip", SqlDbType.Char);
			if(((object)o.Zip) == null){
				param_zip.Value = DBNull.Value;
			}else{
				param_zip.Value = o.Zip;
			}
			if(trans != null)
				cmd.Transaction = trans;
			cmd.ExecuteNonQuery();
			return (Int32)cmd.Parameters["RETURN_VALUE"].Value;
		}

		///<summary>This method creates a new Contact object in database.</summary>
		public static Int32 CreateContact(Contact o)
		{
			Int32 rval = 0;
			SqlConnection conn = DbConnectionHelper.GetConnection();
			conn.Open();
			SqlTransaction trans = conn.BeginTransaction();
			try{
				rval = CreateContact(o,conn,trans);
				trans.Commit();
			}catch(Exception e){
				trans.Rollback();
				throw new ApplicationException("Problem creating a Contact record in the database:"+e.Message);
			}finally{
				conn.Close();
			}
			return rval;
		}

		///<summary>This method updates Contact object in database.</summary>
		public static void UpdateContact(Contact o, SqlConnection conn, SqlTransaction trans)
		{
			SqlCommand cmd = new SqlCommand("UpdateContact",conn);
			cmd.CommandType = CommandType.StoredProcedure;
			SqlParameter param_id = cmd.Parameters.Add("@id", SqlDbType.Int);
			if(((object)o.Id) == null){
				param_id.Value = DBNull.Value;
			}else{
				param_id.Value = o.Id;
			}
			SqlParameter param_fname = cmd.Parameters.Add("@fname", SqlDbType.VarChar);
			if(((object)o.Fname) == null){
				param_fname.Value = DBNull.Value;
			}else{
				param_fname.Value = o.Fname;
			}
			SqlParameter param_lname = cmd.Parameters.Add("@lname", SqlDbType.VarChar);
			if(((object)o.Lname) == null){
				param_lname.Value = DBNull.Value;
			}else{
				param_lname.Value = o.Lname;
			}
			SqlParameter param_email = cmd.Parameters.Add("@email", SqlDbType.VarChar);
			if(((object)o.Email) == null){
				param_email.Value = DBNull.Value;
			}else{
				param_email.Value = o.Email;
			}
			SqlParameter param_url = cmd.Parameters.Add("@url", SqlDbType.VarChar);
			if(((object)o.Url) == null){
				param_url.Value = DBNull.Value;
			}else{
				param_url.Value = o.Url;
			}
			SqlParameter param_phone = cmd.Parameters.Add("@phone", SqlDbType.VarChar);
			if(((object)o.Phone) == null){
				param_phone.Value = DBNull.Value;
			}else{
				param_phone.Value = o.Phone;
			}
			SqlParameter param_fax = cmd.Parameters.Add("@fax", SqlDbType.VarChar);
			if(((object)o.Fax) == null){
				param_fax.Value = DBNull.Value;
			}else{
				param_fax.Value = o.Fax;
			}
			SqlParameter param_street = cmd.Parameters.Add("@street", SqlDbType.VarChar);
			if(((object)o.Street) == null){
				param_street.Value = DBNull.Value;
			}else{
				param_street.Value = o.Street;
			}
			SqlParameter param_city = cmd.Parameters.Add("@city", SqlDbType.VarChar);
			if(((object)o.City) == null){
				param_city.Value = DBNull.Value;
			}else{
				param_city.Value = o.City;
			}
			SqlParameter param_state = cmd.Parameters.Add("@state", SqlDbType.Char);
			if(((object)o.State) == null){
				param_state.Value = DBNull.Value;
			}else{
				param_state.Value = o.State;
			}
			SqlParameter param_zip = cmd.Parameters.Add("@zip", SqlDbType.Char);
			if(((object)o.Zip) == null){
				param_zip.Value = DBNull.Value;
			}else{
				param_zip.Value = o.Zip;
			}
			if(trans != null)
				cmd.Transaction = trans;
			cmd.ExecuteNonQuery();
		}

		///<summary>This method updates Contact object in database.</summary>
		public static void UpdateContact(Contact o)
		{
			SqlConnection conn = DbConnectionHelper.GetConnection();
			conn.Open();
			SqlTransaction trans = conn.BeginTransaction();
			try{
				UpdateContact(o,conn,trans);
				trans.Commit();
			}catch(Exception e){
				trans.Rollback();
				throw new ApplicationException("Problem updating Contact record in the database:"+e.Message);
			}finally{
				conn.Close();
			}
		}

		///<summary>This method deletes Contact object from the database.</summary>
		public static void DeleteContact(Int32 pk, SqlConnection conn, SqlTransaction trans)
		{
			SqlCommand cmd = new SqlCommand("DeleteContact",conn);
			cmd.CommandType = CommandType.StoredProcedure;
			SqlParameter param_id = cmd.Parameters.Add("@id", SqlDbType.Int);
			param_id.Value = pk;
			if(trans != null)
				cmd.Transaction = trans;
			cmd.ExecuteNonQuery();
		}

		///<summary>This method deletes Contact object from the database.</summary>
		public static void DeleteContact(Int32 pk)
		{
			SqlConnection conn = DbConnectionHelper.GetConnection();
			conn.Open();
			SqlTransaction trans = conn.BeginTransaction();
			try{
				DeleteContact(pk,conn,trans);
				trans.Commit();
			}catch(Exception e){
				trans.Rollback();
				throw new ApplicationException("Problem deleting Contact record from the database:"+e.Message);
			}finally{
				conn.Close();
			}
		}

		///<summary>This method gets the Contact object from the database by primary key.</summary>
		public static Contact GetContact(Int32 id)
		{
			SqlConnection conn = DbConnectionHelper.GetConnection();
			SqlCommand cmd = new SqlCommand("GetContact",conn);
			cmd.CommandType = CommandType.StoredProcedure;
			SqlParameter param_id = cmd.Parameters.Add("@id", SqlDbType.Int);
			param_id.Value = id;
			conn.Open();
			SqlDataReader dbreader = cmd.ExecuteReader();
			Contact o = new Contact();
			if (dbreader.Read()){
				if(!dbreader.IsDBNull(0)){
					o.Id = dbreader.GetInt32(0);
				}
				if(!dbreader.IsDBNull(1)){
					o.Fname = dbreader.GetString(1);
				}
				if(!dbreader.IsDBNull(2)){
					o.Lname = dbreader.GetString(2);
				}
				if(!dbreader.IsDBNull(3)){
					o.Email = dbreader.GetString(3);
				}
				if(!dbreader.IsDBNull(4)){
					o.Url = dbreader.GetString(4);
				}
				if(!dbreader.IsDBNull(5)){
					o.Phone = dbreader.GetString(5);
				}
				if(!dbreader.IsDBNull(6)){
					o.Fax = dbreader.GetString(6);
				}
				if(!dbreader.IsDBNull(7)){
					o.Street = dbreader.GetString(7);
				}
				if(!dbreader.IsDBNull(8)){
					o.City = dbreader.GetString(8);
				}
				if(!dbreader.IsDBNull(9)){
					o.State = dbreader.GetString(9);
				}
				if(!dbreader.IsDBNull(10)){
					o.Zip = dbreader.GetString(10);
				}
			}else{
				o = null;
			}
			dbreader.Close();
			conn.Close();
			return o;
		}

		///<summary>This method gets ALL the Contact objects from the database.</summary>
		public static ArrayList GetAllContacts()
		{
			SqlConnection conn = DbConnectionHelper.GetConnection();
			SqlCommand cmd = new SqlCommand("GetAllContacts",conn);
			cmd.CommandType = CommandType.StoredProcedure;
			conn.Open();
			SqlDataReader dbreader = cmd.ExecuteReader();
			ArrayList arr = new ArrayList();
			while (dbreader.Read()){
				Contact o = new Contact();
				if(!dbreader.IsDBNull(0)){
					o.Id = dbreader.GetInt32(0);
				}
				if(!dbreader.IsDBNull(1)){
					o.Fname = dbreader.GetString(1);
				}
				if(!dbreader.IsDBNull(2)){
					o.Lname = dbreader.GetString(2);
				}
				if(!dbreader.IsDBNull(3)){
					o.Email = dbreader.GetString(3);
				}
				if(!dbreader.IsDBNull(4)){
					o.Url = dbreader.GetString(4);
				}
				if(!dbreader.IsDBNull(5)){
					o.Phone = dbreader.GetString(5);
				}
				if(!dbreader.IsDBNull(6)){
					o.Fax = dbreader.GetString(6);
				}
				if(!dbreader.IsDBNull(7)){
					o.Street = dbreader.GetString(7);
				}
				if(!dbreader.IsDBNull(8)){
					o.City = dbreader.GetString(8);
				}
				if(!dbreader.IsDBNull(9)){
					o.State = dbreader.GetString(9);
				}
				if(!dbreader.IsDBNull(10)){
					o.Zip = dbreader.GetString(10);
				}
				arr.Add(o);
			}
			dbreader.Close();
			conn.Close();
			return arr;
		}

		///<summary>Lookup contact by first name/last name.</summary>
		public static ArrayList GetFindContact(String qstr)
		{
			SqlConnection conn = DbConnectionHelper.GetConnection();
			SqlCommand cmd = new SqlCommand("GetFindContact",conn);
			cmd.CommandType = CommandType.StoredProcedure;
			SqlParameter param_qstr = cmd.Parameters.Add("@qstr", SqlDbType.VarChar);
			param_qstr.Value = qstr;
			conn.Open();
			SqlDataReader dbreader = cmd.ExecuteReader();
			ArrayList arr = new ArrayList();
			while (dbreader.Read()){
				Contact o = new Contact();
				if(!dbreader.IsDBNull(0)){
					o.Id = dbreader.GetInt32(0);
				}
				if(!dbreader.IsDBNull(1)){
					o.Fname = dbreader.GetString(1);
				}
				if(!dbreader.IsDBNull(2)){
					o.Lname = dbreader.GetString(2);
				}
				if(!dbreader.IsDBNull(3)){
					o.Email = dbreader.GetString(3);
				}
				if(!dbreader.IsDBNull(4)){
					o.Url = dbreader.GetString(4);
				}
				if(!dbreader.IsDBNull(5)){
					o.Phone = dbreader.GetString(5);
				}
				if(!dbreader.IsDBNull(6)){
					o.Fax = dbreader.GetString(6);
				}
				if(!dbreader.IsDBNull(7)){
					o.Street = dbreader.GetString(7);
				}
				if(!dbreader.IsDBNull(8)){
					o.City = dbreader.GetString(8);
				}
				if(!dbreader.IsDBNull(9)){
					o.State = dbreader.GetString(9);
				}
				if(!dbreader.IsDBNull(10)){
					o.Zip = dbreader.GetString(10);
				}
				arr.Add(o);
			}
			dbreader.Close();
			conn.Close();
			return arr;
		}

		///<summary>This method gets the count of Contact objects in the database.</summary>
		public static Int32 GetContactCount()
		{
			SqlConnection conn = DbConnectionHelper.GetConnection();
			SqlCommand cmd = new SqlCommand("GetContactCount",conn);
			cmd.CommandType = CommandType.StoredProcedure;
			conn.Open();
			Int32 n = (Int32)cmd.ExecuteScalar();
			conn.Close();
			return n;
		}

	}

}
